<!---
	This file outputs it's own Abstract Syntax Tree.
--->
<cffunction name="d">
	<cfargument name="o">
	
	<cfdump var="#createObject("java",o)#">
</cffunction>

<!---
<cfset d("coldfusion.compiler.NeoTranslator")>
<cfset d("coldfusion.runtime.Variable")>
<cfset d("coldfusion.runtime.StringFunc")>
<cfset d("coldfusion.runtime.Cast")>
--->

<cffunction name="getCFAST" output="false">
	<cfargument name="fileName" type="string" required="true">
	
	<cfset var ServletContext = getPageContext().getServletContext().getContext("/")>
	<cfset var c = createObject("java","coldfusion.compiler.NeoTranslator").init(ServletContext)>
	<cfset var cftags = c.getClass().getDeclaredField("cftags")>
	<cfset var sourceFile = createObject("java","java.io.File").init(arguments.fileName)>
	<cfset var translationContext = createObject("java","coldfusion.compiler.NeoTranslationContext").getClass().getDeclaredConstructors()>
	<cfset var args = arrayNew(1)>
	<cfset var parsePage = "">
	
	<cfset cftags.setAccessible(true)>
	<cfset cftags = cftags.get(c)>

	<cfset args[1] = cftags>
	<cfset args[2] = ServletContext>
	<cfset args[3] = sourceFile>
	<cfset args[4] = "testclass">
	<cfset translationContext[1].setAccessible(true)>
	<cfset TranslationContext = translationContext[1].newInstance(args)>
	
	<cfset args = arrayNew(1)>
	<cfset args[1] = translationContext.getClass()>
	
	<cfset parsePage = c.getClass().getDeclaredMethod("parsePage",args)>
	<cfset parsePage.setAccessible(true)>
	
	<cfset args = arrayNew(1)>
	<cfset args[1] = translationContext>
	
	<cfreturn parsePage.invoke(c,args)>
</cffunction>

<cffunction name="getCFASTTokens" output="false">
	<cfargument name="ast" required="true">
	<cfset var tokens = arrayNew(1)>
	<cfset var node = ast.getStartToken()>
	<cfloop condition="#isDefined('node')#">
		<cfset arrayAppend( tokens, node.toString() )>
		<cftry>
			<cfset node = node.next>
		<cfcatch>
			<cfbreak>
		</cfcatch>
		</cftry>
	</cfloop>
	<cfreturn tokens>
</cffunction>

<cfset ast = getCFAST(expandPath("test.cfm"))>

<!---cfdump var="#ast.jjtGetChild(0).jjtGetChild(0).getNamedAttribute("RVAL").getOperator().toString()#"--->
<cfdump var="#getCFASTTokens(ast)#">