<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
	"http://www.w3.org/TR/html4/strict.dtd">

<style type="text/css">
	h1 { font-size: 1.2em }
	h2 { font-size: 1em }
</style>

<cffunction name="getClassNameAndDump">
	<cfargument name="className" type="string" required="false">
	<cfargument name="variable" type="any" required="false">
	
	<cfif structKeyExists(arguments,"variable")>
		<cfset arguments.className = getMetaData(arguments.variable).getName()>
	</cfif>

	<cfoutput>
		<h2>#arguments.className#</h2>
	</cfoutput>
	
	<cfdump var="#createObject('java',arguments.className)#">
</cffunction>

<!---
	What class is a variable (container)?
--->
<h1>Variable</h1>
<cfset getClassNameAndDump("coldfusion.runtime.Variable")>

<!---
	What kind of class is the variables scope?
--->
<h1>Variables Scope</h1>
<cfset getClassNameAndDump(variable = variables)>

<!--- Other Scopes --->
<h1>Cgi Scope</h1>
<cfset getClassNameAndDump(variable = cgi)>

<h1>Url Scope</h1>
<cfset getClassNameAndDump(variable = url)>

<h1>Client Scope</h1>
<cfset getClassNameAndDump(variable = client)>

<h1>Session Scope</h1>
<cfset getClassNameAndDump(variable = session)>

<!--- Tried this, Nope!
<cfset coldfusion.runtime.ServerScope = createObject("java","coldfusion.runtime.ServerScope")>
--->

<!--- So it's something else --->
<h1>Server Scope</h1>
<cfset getClassNameAndDump(variable = server)>
