<!---
	Example of using the Transaction component.
--->

<cfset t = createObject("component", "Transaction").init()>

<cftry>

<cfset t.begin()>

<cftry>
	<cfquery datasource="community">
		delete from members where name = 'Test User'
	</cfquery>

	<cfquery datasource="community">
		insert into members (email,name,password)
		values ('test1@test.com','Test User','')
	</cfquery>
	
	<!--- 
		This causes a duplicate key (email) so this we'll
		end up in the catch below.
	--->
	<cfquery datasource="community">
		insert into members (email,name,password)
		values ('test1@test.com','Test User','')
	</cfquery>	
	
	<cfcatch type="any">
		<cfset t.rollback()>
	</cfcatch>
</cftry>

<cfset t.end()>

<cfquery name="r" datasource="community">
	select * from members
</cfquery>
<cfdump var="#r#">
